package eu.ztsh.training.hackerrank.datastructures;

import java.util.Arrays;
import java.util.Scanner;

/**
 * source: <a href="https://www.hackerrank.com/challenges/java-comparator">Java Comparator</a>
 */
class Checker implements java.util.Comparator<Player> {

    @Override
    public int compare(Player o1, Player o2) {
        var points = o2.score - o1.score;
        return points != 0 ? points : o1.name.compareTo(o2.name);
    }

}

// Hackerrank code below (slightly modified)
public class Comparator {

    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        int n = scan.nextInt();

        Player[] player = new Player[n];
        Checker checker = new Checker();

        for (int i = 0; i < n; i++) {
            player[i] = new Player(scan.next(), scan.nextInt());
        }
        scan.close();

        Arrays.sort(player, checker);
        Arrays.stream(player).forEach(value -> System.out.printf("%s %s%s", value.name, value.score, System.lineSeparator()));
    }

}

class Player {

    String name;
    int score;

    Player(String name, int score) {
        this.name = name;
        this.score = score;
    }

}
